//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 変換モデルマネージャ実装
 * @author Junpee
 */

#include "System/stdafx.h"
#include "Translator/Model/TranslationModelManager.h"
#include "Translator/Model/TranslationCharacterModel.h"

namespace LampForMaya{

//------------------------------------------------------------------------------
// コンストラクタ
TranslationModelManager::TranslationModelManager() :
	database_(256, 0.75f), array_(256){
}
//------------------------------------------------------------------------------
// デストラクタ
TranslationModelManager::~TranslationModelManager(){
	Assert(database_.getCount() == 0);
	Assert(array_.getCount() == 0);
	if(getCount() != 0){ clear(); }
}
//------------------------------------------------------------------------------
// モデルの収集
bool TranslationModelManager::collectModels(
	TranslationMeshManager* meshManager){
	meshManager_ = meshManager;
	MStatus result;
	// 幅優先DAGイテレータ
	MItDag dagIterator(MItDag::kBreadthFirst, MFn::kInvalid, &result);
	MayaStatusCheck(result);
	MDagPath dagPath;
	for( ; !dagIterator.isDone(); dagIterator.next()){
		result = dagIterator.getPath(dagPath);
		MayaStatusCheck(result);
		// モデル解析
		if(!analysisModel(dagPath)){ return false; }
	}
	return true;
}
//------------------------------------------------------------------------------
// モデルの解析
bool TranslationModelManager::analysisModel(MDagPath dagPath){
	MStatus result;
	MFnDagNode dagNode(dagPath, &result);
	MayaStatusCheck(result);
	// 中間オブジェクトならキャンセル
	if(dagNode.isIntermediateObject()){ return true; }
	// メッシュファンクションを持っていなければキャンセル
	if(!dagPath.hasFn(MFn::kMesh)){ return true; }
	// トランスフォームファンクションを持っていればキャンセル
	if(dagPath.hasFn(MFn::kTransform)){ return true; }
	// オブジェクトの取得
	MObject modelObject = dagPath.node(&result);
	MayaStatusCheck(result);
	// 名前の重複が無いかチェック
	String modelName = dagNode.name(&result).asChar();
	MayaStatusCheck(result);
	TranslationModel* exist = database_.get(modelName);
	if(exist != NULL){
		// オブジェクトが同じならインスタンスなので読み飛ばし、そうでなければエラー
		if(exist->getObject() != modelObject){
			MayaErrorOut(String("TranslationModelManager::analysisModel() "
				"名前が重複しています ") + modelName);
			return false;
		}
		return true;
	}

	// キャラクタメッシュの判別
	MPlug inMeshPlug = MayaNodeUtility::getPlug(modelObject, "inMesh");
	// 失敗する場合があるのでresultはチェックしない
	MItDependencyGraph characterIterator(inMeshPlug,
		MFn::kSkinClusterFilter, MItDependencyGraph::kUpstream,
		MItDependencyGraph::kBreadthFirst,
		MItDependencyGraph::kNodeLevel, &result);
	MObject inMesh = characterIterator.thisNode(&result);
	TranslationModel* model = NULL;
	if((!inMesh.isNull()) && inMesh.hasFn(MFn::kSkinClusterFilter)){
		// スキンクラスタならキャラクタモデル
		model = new TranslationCharacterModel(modelObject, modelName, inMesh);
	}else{
		// そうでなければスタンダードモデル
		model = new TranslationStandardModel(modelObject, modelName);
	}

	// モデルのアナライズ
	if(!model->analyze(meshManager_)){
		delete model;
		return false;
	}
	// データベースに追加
	database_.put(modelName, model);
	array_.add(model);
	return true;
}
//------------------------------------------------------------------------------
// アニメーションの収集
bool TranslationModelManager::collectAnimations(){
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->analyzeAnimation()){ return false; }
	}
	return true;
}
//------------------------------------------------------------------------------
// Lampへの変換
bool TranslationModelManager::convertToLamp(Scene* scene) const{
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->convertToLamp(scene)){ return false; }
	}
	return true;
}
//------------------------------------------------------------------------------
// アニメーションの変換
bool TranslationModelManager::convertAnimation(
	AnimationManager* animationManager, AnimationSet* animationSet){
	for(int i = 0; i < getCount(); i++){
		if(!get(i)->convertAnimation(animationManager, animationSet)){
			return false;
		}
	}
	return true;
}
//------------------------------------------------------------------------------
// クリア
int TranslationModelManager::clear(){
	int result = getCount();
	// 要素の削除
	for(int i = 0; i < result; i++){ delete array_.get(i); }
	array_.clear();
	database_.clear();
	return result;
}
//------------------------------------------------------------------------------
} // End of namespace LampForMaya
//------------------------------------------------------------------------------
